<?php
  include("conn.php");
  include("fnc-titulares.php");
  //Recupero parametros
  $vFecha            = $_POST['xFecha'];
  $vDataPeriodos     = $_POST['xDataPeriodos'];
  $vUnidades         = $_POST['xUnidades'];
  $vConceptos        = $_POST['xConceptos'];
  $vRubros           = $_POST['xRubros'];
  $vComprobantes     = $_POST['xComprobantes'];

  $sqlVistaTitulares = getVistaTitulres($DBSegu);

  $sql = "SELECT PUESTO FROM " . $_SESSION["BaseMadre"] . "glPuestos WHERE DESCRI = 'TABLERO_WEB'";
  $RsPuesto = $DBSegu->Execute($sql);
  if (!$RsPuesto) {
    $jsondata['success'] = false;
    $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.01';
    header('Content-type: application/json; charset=utf-8');
    echo json_encode($jsondata);
    die();  
  }

  if ($RsPuesto->RecordCount() > 0) { 
    $sql = "SELECT PARAM FROM " . $_SESSION["BaseMadre"] . "glConfig WHERE PUESTO = " . $RsPuesto->fields['PUESTO'] . " AND CLAVE = 'COD_BARRA_VE'";
    $RsPuesto = $DBSegu->Execute($sql);
    if (!$RsPuesto) {
      $jsondata['success'] = false;
      $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.02';
      header('Content-type: application/json; charset=utf-8');
      echo json_encode($jsondata);
      die();  
    }

    if ($RsPuesto->RecordCount() == 0) {
      $muestraCodigo = 0; //rubro-codigo
    }
    else {
      if ($RsPuesto->fields['PARAM'] == 1) {
        $muestraCodigo = 1; //cod-barra
      }
      else {
        $muestraCodigo = 0; //rubro-codigo
      }
    }
  }
  else {
    $muestraCodigo = 0; //rubro-codigo
  }

//Armo el filtro de periodos;
  $sqlPeriodos = "";
  if ($vDataPeriodos != '') {
    $xDataPeriodos = json_decode($vDataPeriodos);
    $sqlPeriodos = " AND (";
    foreach ($xDataPeriodos as $value) {
      if ($sqlPeriodos <> " AND (") {
        $sqlPeriodos .= " OR ";
      }
      /*switch ($vFecha) {
        case '0':
          $sqlPeriodos .= "(X.FECHA BETWEEN '" . $value->desde . "' AND '" . $value->hasta . "')";
        break;
        case '1':
          $sqlPeriodos .= "(X.FECHA_CARGA BETWEEN '" . $value->desde . "' AND '" . $value->hasta . "')";
        break;
        case '2':
          $sqlPeriodos .= "(X.FECHA_STOCK BETWEEN '" . $value->desde . "' AND '" . $value->hasta . "')";
        break;
      }*/
      //este consulta contra veventas asi que siempre filtra por fecha
      $sqlPeriodos .= "(X.FECHA BETWEEN '" . $value->desde . "' AND '" . $value->hasta . "')";
    }
    $sqlPeriodos .= ")";
  }
  
  //Armo la lista titulares
  //Si no hay ningun titular tengo que traer todos
  $cantidadTitulares = 0;
  if ($vUnidades == '') {
    $sqlAdmin = ($_SESSION['CurrentAdmin'] == 0)?" AND UB.ID_USUARIO = ".$_SESSION['CurrentIdUser']:"";
    $sql = "SELECT DISTINCT B.BASE, B.DESCRI AS DESC_BASE, T.TITULAR, T.DESCRI AS DESC_TITULAR
            FROM (SELECT XB.BASE, XB.DESCRI 
                  FROM BASES XB 
                       INNER JOIN USUARIOSBASES XUB 
                           INNER JOIN USUARIOS XU 
                           ON XUB.ID_USUARIO = XU.ID_USUARIO 
                              AND XU.USUARIO = 'PIXO_WEB' 
                       ON XB.BASE = XUB.BASE) B  
                 INNER JOIN ".$sqlVistaTitulares." T
                 ON B.BASE = T.BASE
                 INNER JOIN USUARIOSBASES UB 
                     INNER JOIN USUARIOS U 
                     ON UB.ID_USUARIO = U.ID_USUARIO 
                 ON B.BASE = UB.BASE ".$sqlAdmin."
            ORDER BY B.DESCRI ";
    $RsUnidades = sqlsrv_query( $conn, $sql);    
    if (! $RsUnidades ) {    
      $jsondata['success'] = false;
      $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.11';
      header('Content-type: application/json; charset=utf-8');
      echo json_encode($jsondata);
      die( print_r( sqlsrv_errors(), true));    
    }
    while( $row = sqlsrv_fetch_array( $RsUnidades, SQLSRV_FETCH_ASSOC)) {  
      if ($vUnidades != '') {$vUnidades.=',';}
      $vUnidades .= $row['BASE'].'-'.$row['TITULAR']; 
    }
  } 
  $xDataTitulares = explode(',', $vUnidades );
  foreach ($xDataTitulares as $value) {
    $cantidadTitulares ++;
  }

  //Armo el filtro de empresas
  //el filtro de titulares se hace luego en el while de cada empresa
  $sqlEmpresas = '';
  if ($vUnidades != '') {
    $xUnidades = explode(',' , $vUnidades);
    $sqlEmpresas = " AND (";
    foreach ($xUnidades as $value) {
      $aux = explode('-', $value);
      
      if ($sqlEmpresas <> " AND (") {
        $sqlEmpresas .= " OR ";
      }
      $sqlEmpresas .= "(E.BASE = " . $aux[0] . ")";
    }
    $sqlEmpresas .= ")";
  }

  //Armo el filtro de conceptos y rubros; uso solo sqlProductos para ambos
  //ninguno
  if (($vConceptos == '') && ($vRubros == '')) {
    $sqlProductos = '';
  }

  //solo conceptos
  if (($vConceptos != '') && ($vRubros == '')) {
    $sqlProductos = '';
    $xConceptos = explode(',' , $vConceptos);
    $sqlProductos = " AND (";
    foreach ($xConceptos as $value) {
      if ($sqlProductos <> " AND (") {
        $sqlProductos .= " OR ";
      }
      $sqlProductos .= "(I.CONCEPTO = " . $value . ")";
    }
    $sqlProductos .= ")";
  }  

  //solo rubros
  if (($vConceptos == '') && ($vRubros != '')) {
    $sqlProductos = '';
    $xRubros = explode(',' , $vRubros);
    $sqlProductos = " AND (";
    foreach ($xRubros as $value) {
      if ($sqlProductos <> " AND (") {
        $sqlProductos .= " OR ";
      }
      $sqlProductos .= "(R.RUBRO = " . $value . ")";
    }
    $sqlProductos .= ")";
  }  

  //ambos
  if (($vConceptos != '') && ($vRubros != '')) {
    $sqlProductos = '';
    $xRubros = explode(',' , $vRubros);
    $xConceptos = explode(',' , $vConceptos);
    $sqlProductos = " AND (";
    foreach ($xRubros as $value) {
      if ($sqlProductos <> " AND (") {
        $sqlProductos .= " OR ";
      }
      $sqlProductos .= "(R.RUBRO = " . $value . ")";
    }
    foreach ($xConceptos as $value) {
      if ($sqlProductos <> " AND (") {
        $sqlProductos .= " OR ";
      }
      $sqlProductos .= "(I.CONCEPTO = " . $value . ")";
    }
    $sqlProductos .= ")";
  }  

  //Armo el filtro de comprobantes
  $sqlComprobantes = '';
  if ($vComprobantes != '') {
    $xComprobantes = explode(',' , $vComprobantes);
    $sqlComprobantes = " AND (";
    foreach ($xComprobantes as $value) {
    //$value->desde;
      if ($sqlComprobantes <> " AND (") {
        $sqlComprobantes .= " OR ";
      }
      $sqlComprobantes .= "(X.TIPO_MOV = " . $value . ")";
    }
    $sqlComprobantes .= ")";
  }

  function getNombreTitular($conn, $valor, $vista) {
    $axu = explode('-', $valor);
    $sqlAdmin = ($_SESSION['CurrentAdmin'] == 0)?" AND UB.ID_USUARIO = ".$_SESSION['CurrentIdUser']:"";
    $sql = "SELECT DISTINCT B.BASE, B.DESCRI AS DESC_BASE, T.TITULAR, T.DESCRI AS DESC_TITULAR
            FROM (SELECT XB.BASE, XB.DESCRI 
                  FROM BASES XB 
                       INNER JOIN USUARIOSBASES XUB 
                           INNER JOIN USUARIOS XU 
                           ON XUB.ID_USUARIO = XU.ID_USUARIO 
                              AND XU.USUARIO = 'PIXO_WEB' 
                       ON XB.BASE = XUB.BASE) B  
                 INNER JOIN ".$vista." T
                 ON B.BASE = T.BASE
                 INNER JOIN USUARIOSBASES UB 
                     INNER JOIN USUARIOS U 
                     ON UB.ID_USUARIO = U.ID_USUARIO 
                 ON B.BASE = UB.BASE ".$sqlAdmin."
            WHERE B.BASE = ".$axu[0]." AND T.TITULAR = " . $axu[1];
    $RsTitular = sqlsrv_query( $conn, $sql);    
    if (! $RsTitular ) {    
      $jsondata['success'] = false;
      $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.12';
      header('Content-type: application/json; charset=utf-8');
      echo json_encode($jsondata);
      die( print_r( sqlsrv_errors(), true));    
    }
    $row = sqlsrv_fetch_array( $RsTitular, SQLSRV_FETCH_ASSOC);
    return utf8_encode($row['DESC_BASE']) . ' - ' . utf8_encode($row['DESC_TITULAR']);
  }

  function getTitulares($lista, $base) {
    $resu = '';

    if ($lista != '') {
      $xUnidades = explode(',' , $lista);
      $xxx = '';
      foreach ($xUnidades as $value) {
        $aux = explode('-', $value);
        if ($aux[0] == $base) {
          if ($xxx <> "") {
            $xxx .= ", ";
          }
        $xxx .= " " . $aux[1];
        }
      }
      $resu = " AND TITULAR IN (" . $xxx . ")";
    }

    return $resu;
  }
  $resu = '';

  //armo el script para crear la tabla temporal; la cantidad de columnas va a depender del la cantidad de periodos;
  $sqlTemporal = "create table #TablaTemporal (CONCEPTO INT, CODIGO INT, RUBRO INT, DESC_INSUMO varchar(250), DESC_RUBRO VARCHAR(250), DESC_UNIDAD VARCHAR(250), CANTIDAD1 MONEY default 0, BARRA varchar(250)";
  for ($i = 2; $i <= $cantidadTitulares; $i++) {
    $sqlTemporal .= ", CANTIDAD".$i." MONEY default 0";
  }
  $sqlTemporal .= ")";

  $RsTemporal = sqlsrv_query( $conn, $sqlTemporal);    
  if (! $RsTemporal ) {    
    $jsondata['success'] = false;
    $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.03';
    header('Content-type: application/json; charset=utf-8');
    echo json_encode($jsondata);
    die( print_r( sqlsrv_errors(), true));    
  }    
/*  $RsTemporal = $DBSegu->Execute($sqlTemporal);
  if (!$RsTemporal) {
    $jsondata['success'] = false;
    $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.00';
    header('Content-type: application/json; charset=utf-8');
    echo json_encode($jsondata);
    die();  
  }*/

  $sqlTemporal = "create NONCLUSTERED INDEX idx_TablaTemporal ON #TablaTemporal (CONCEPTO)";
  $RsTemporal = sqlsrv_query( $conn, $sqlTemporal);    
  if (! $RsTemporal ) {    
    $jsondata['success'] = false;
    $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.04';
    header('Content-type: application/json; charset=utf-8');
    echo json_encode($jsondata);
    die( print_r( sqlsrv_errors(), true));    
  }    
/*  $RsTemporal = $DBSegu->Execute($sqlTemporal);
  if (!$RsTemporal) {
    $jsondata['success'] = false;
    $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.00';
    header('Content-type: application/json; charset=utf-8');
    echo json_encode($jsondata);
    die();  
  }*/

  $misDatos = array();
  $ordenTitular = 0;
  foreach ($xDataTitulares as $value) {
    $aux = explode('-', $value);
    $tmpTitular = $aux[1];
    $ordenTitular ++;
    $sqlAdmin = ($_SESSION['CurrentAdmin'] == 0)?" AND UB.ID_USUARIO = ".$_SESSION['CurrentIdUser']:"";
    $sqlBases = "SELECT DISTINCT E.BASE, E.DESCRI, E.NOMBRE_BASE 
                 FROM (SELECT XB.BASE, XB.DESCRI, XB.NOMBRE_BASE 
                       FROM BASES xB 
                            INNER JOIN USUARIOSBASES XUB 
                                INNER JOIN USUARIOS XU 
                                ON XUB.ID_USUARIO = XU.ID_USUARIO 
                                AND XU.USUARIO = 'PIXO_WEB' 
                            ON XB.BASE = XUB.BASE) E 
                      INNER JOIN USUARIOSBASES UB 
                          INNER JOIN USUARIOS U 
                          ON UB.ID_USUARIO = U.ID_USUARIO 
                      ON E.BASE = UB.BASE ".$sqlAdmin."
                 WHERE 1=1 AND E.BASE = ".$aux[0]."
                 ORDER BY E.DESCRI";
    $RsEmpresas = $DBSegu->Execute($sqlBases);
    if (!$RsEmpresas) {
      $jsondata['success'] = false;
      $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.05';
      header('Content-type: application/json; charset=utf-8');
      echo json_encode($jsondata);
      die();  
    }
    
    $subConsulta = '';
    //Esta consulta devuelve un solo registro ya que se ejecuta una vez por cada empresa, 
    //luego si, dentro de este falso ciclo debo filtrar el titular que quiero consultar
    while (!$RsEmpresas->EOF) {
      //$sqlTitulares = getTitulares($vUnidades, $RsEmpresas->fields['BASE']); 
      $sqlTitulares = " AND TITULAR IN (" . $tmpTitular . ")";
      if ($subConsulta != '') {
        $subConsulta .= ' UNION ALL ';
      };

      $subConsulta .= "select " . $RsEmpresas->fields['BASE'] . " as base, X.comprob, IP.concepto_insu as insumo, 
                              (IV.cantidad * IP.cantidad) as cantidad, X.fecha, TM.credito, X.titular, X.tipo_mov  
                       from " . $RsEmpresas->fields["NOMBRE_BASE"] . ".dbo.veventas X 
                            inner join " . $RsEmpresas->fields["NOMBRE_BASE"] . ".dbo.veimputa IV 
                                inner join " . $RsEmpresas->fields["NOMBRE_BASE"] . ".dbo.glinsuprod IP 
                                on IV.concepto = IP.concepto_prod 
                            on X.comprob = IV.comprob 
                            inner join " . $RsEmpresas->fields["NOMBRE_BASE"] . ".dbo.vetipomov TM 
                            on TM.tipo_mov = X.tipo_mov and not TM.tipo_mov_cc is null  
                       where 1=1 " .
                             $sqlPeriodos .
                             $sqlTitulares . "
                       union 
                       Select " . $RsEmpresas->fields['BASE'] . " as base, X.comprob, IV.concepto as insumo, IV.cantidad, 
                              X.fecha, TM.credito, X.titular, X.tipo_mov 
                       From " . $RsEmpresas->fields["NOMBRE_BASE"] . ".dbo.veventas X 
                            inner join " . $RsEmpresas->fields["NOMBRE_BASE"] . ".dbo.veimputa IV 
                                inner join " . $RsEmpresas->fields["NOMBRE_BASE"] . ".dbo.glconceptos INS 
                                    inner join " . $RsEmpresas->fields["NOMBRE_BASE"] . ".dbo.glrubros R 
                                    on INS.rubro = R.rubro 
                                on IV.concepto = INS.concepto 
                            on X.comprob = IV.comprob 
                            inner join " . $RsEmpresas->fields["NOMBRE_BASE"] . ".dbo.vetipomov TM 
                            on TM.tipo_mov = X.tipo_mov and not TM.tipo_mov_cc is null  
                       where 1=1 " .
                             $sqlPeriodos .
                             $sqlTitulares . "
                         and INS.stock = 1 
                         and IV.concepto not in (select concepto_prod 
                                                 from " . $RsEmpresas->fields["NOMBRE_BASE"] . ".dbo.glinsuprod 
                                                 where tipo <> 2)";

      $RsEmpresas->MoveNext();
    }

    //ERA CON RIGHT OUTER
    $sqlConsulta = "Select R.codigo as RUBRO, I.CONCEPTO, I.CODIGO, I.COD_BARRA, R.descri as DESC_RUBRO, 
                           I.descri as DESC_INSUMO, U.descri as UNIDAD,
                           round(isnull(sum(cantidad * " . $_SESSION["BaseMadre"] . "valorcredito(V.credito)), 0), 2) as CANTIDAD
                    from (" .$subConsulta. ")  V  
                         inner join " . $_SESSION["BaseMadre"] . "glconceptos I 
                             inner join " . $_SESSION["BaseMadre"] . "glrubros R 
                             on I.rubro = R.rubro 
                             inner join " . $_SESSION["BaseMadre"] . "glunidades U 
                             on I.unidad = U.unidad " .
                             $sqlProductos . "
                         on V.insumo = I.concepto 
                    group by R.codigo, I.concepto, I.codigo, R.descri, I.descri, U.descri, I.COD_BARRA
                    order by R.codigo, I.codigo ";

//echo $sqlConsulta;
    $RsConsulta = $DBSegu->Execute($sqlConsulta);
    if (!$RsConsulta) {
      $jsondata['success'] = false;
      $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.06';
      header('Content-type: application/json; charset=utf-8');
      echo json_encode($jsondata);
      die();  
    }
   
    while (!$RsConsulta->EOF) {
      //echo $RsConsulta->fields['CONCEPTO'].'  ----  ';
      if ($ordenTitular == 1) {
        $sqlTemporal = "insert into #TablaTemporal (CONCEPTO, CODIGO, DESC_INSUMO, RUBRO, DESC_RUBRO, DESC_UNIDAD, CANTIDAD1, BARRA) 
                          values (".$RsConsulta->fields['CONCEPTO'].", ".$RsConsulta->fields['CODIGO'].", '".
                          utf8_encode($RsConsulta->fields['DESC_INSUMO'])."', ".
                          $RsConsulta->fields['RUBRO'].", '".utf8_encode($RsConsulta->fields['DESC_RUBRO'])."', '".
                          utf8_encode($RsConsulta->fields['UNIDAD']) . "', " .
                          $RsConsulta->fields['CANTIDAD'].", '" . $RsConsulta->fields['COD_BARRA']. "')";
        $RsTemporal = sqlsrv_query( $conn, $sqlTemporal);    
        if (! $RsTemporal ) {    
          $jsondata['success'] = false;
          $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.07';
          header('Content-type: application/json; charset=utf-8');
          echo json_encode($jsondata);
          die( print_r( sqlsrv_errors(), true));    
        }    
        // $RsTemporal = $DBSegu->Execute($sqlTemporal);
      }
      else {
        $sqlTemporal = "update #TablaTemporal set CANTIDAD".$ordenTitular."=".$RsConsulta->fields['CANTIDAD']." where CONCEPTO=".$RsConsulta->fields['CONCEPTO'] . " IF @@ROWCOUNT = 0 BEGIN  insert into #TablaTemporal (CONCEPTO, CODIGO, DESC_INSUMO, RUBRO, DESC_RUBRO, DESC_UNIDAD, CANTIDAD".$ordenTitular.", BARRA) 
                          values (".$RsConsulta->fields['CONCEPTO'].", ".$RsConsulta->fields['CODIGO'].", '".utf8_encode($RsConsulta->fields['DESC_INSUMO'])."', ".
                          $RsConsulta->fields['RUBRO'].", '".utf8_encode($RsConsulta->fields['DESC_RUBRO'])."', '".
                          utf8_encode($RsConsulta->fields['UNIDAD']) . "', ".
                          $RsConsulta->fields['CANTIDAD'].", '" . $RsConsulta->fields['COD_BARRA']. "') END";
        $RsTemporal = sqlsrv_query( $conn, $sqlTemporal);    
        if (! $RsTemporal ) {    
          $jsondata['success'] = false;
          $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.08';
          header('Content-type: application/json; charset=utf-8');
          echo json_encode($jsondata);
          die( print_r( sqlsrv_errors(), true));    
        }    
        //$RsTemporal = $DBSegu->Execute($sqlTemporal);
      }
      $RsConsulta->MoveNext();
    }
  } 

  //Obtengo los totales (para poder sacar porcentaje)
  $sqlTotal = "select SUM(CANTIDAD1) AS CANTIDAD1 ";
  for ($i = 2; $i <= $cantidadTitulares; $i++) {
    $sqlTotal .= ", SUM(CANTIDAD".$i.") AS CANTIDAD".$i." ";
  }
  $sqlTotal .= "FROM #TablaTemporal  
                  WHERE CANTIDAD1 <> 0 ";
  for ($i = 2; $i <= $cantidadTitulares; $i++) {
    $sqlTotal .= " OR CANTIDAD".$i." <> 0 ";
  }
  $RsTotales = sqlsrv_query( $conn, $sqlTotal);    
  if (! $RsTotales ) {    
    $jsondata['success'] = false;
    $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.09';
    header('Content-type: application/json; charset=utf-8');
    echo json_encode($jsondata);
    die( print_r( sqlsrv_errors(), true));    
  }    
  $rowTotales = sqlsrv_fetch_array( $RsTotales, SQLSRV_FETCH_ASSOC);
  /*$RsTotales = $DBSegu->Execute($sqlTotal);
  if (!$RsTotales) {
    $jsondata['success'] = false;
    $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.04';
    header('Content-type: application/json; charset=utf-8');
    echo json_encode($jsondata);
    die();  
  }*/

  //Obtengo del detalle a mostrar
  $sqlTemporal = "select CONCEPTO, CODIGO, RUBRO, DESC_INSUMO, DESC_RUBRO, DESC_UNIDAD, CANTIDAD1 ";
  for ($i = 2; $i <= $cantidadTitulares; $i++) {
    $sqlTemporal .= ", CANTIDAD".$i." ";
  }
  $sqlTemporal .= "FROM #TablaTemporal  
                  WHERE CANTIDAD1 <> 0 ";
  for ($i = 2; $i <= $cantidadTitulares; $i++) {
    $sqlTemporal .= " OR CANTIDAD".$i." <> 0 ";
  }
  $sqlTemporal .= "order by RUBRO, CODIGO";
  $RsTemporal = sqlsrv_query( $conn, $sqlTemporal);    
  if (! $RsTemporal ) {    
    $jsondata['success'] = false;
    $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.10';
    header('Content-type: application/json; charset=utf-8');
    echo json_encode($jsondata);
    die( print_r( sqlsrv_errors(), true));    
  }    
/*  $RsTemporal = $DBSegu->Execute($sqlTemporal);
  if (!$RsTemporal) {
    $jsondata['success'] = false;
    $jsondata['message'] = 'Ha ocurrido un error durante la consulta. Ref. #V01.05';
    header('Content-type: application/json; charset=utf-8');
    echo json_encode($jsondata);
    die();  
  }*/
  //ACA DEBO METER CORTE DE CONTROL POR RUBRO y en el título debo poner correctamente el de cada periodo
  $resu = ' <div class="row">
              <table id="tablaResultado" class="display table table-striped table-bordered sticky-header" style="width:100%">
                <thead style="background-color: #db5916; color: aliceblue;">
                  <tr>
                    <th class="thalign" rowspan="2">C&oacute;digo</th>
                    <th class="thalign tituloshead" rowspan="2">DESCRIPCI&Oacute;N</th>
                    <th class="thalign" rowspan="2">UNIDAD</th>';
  for ($i = 1; $i <= $cantidadTitulares; $i++) {
    $xMostrar = getNombreTitular($conn,$xDataTitulares[$i-1],$sqlVistaTitulares);
    $resu .= '      <th class="thalign fechastable" style="border-bottom: 0px;">'.$xMostrar . '</th>';
  }
  $resu .='       </tr>
                  <tr>';
  for ($i = 1; $i <= $cantidadTitulares; $i++) {
    $resu .= '    <th style="width: 10%;" class="thalign tituloshead">Cantidad</th>';
  }
  $resu .='       </tr>
                </thead>
               <tbody>';
  $rubroAnt = -1;

  $acumuladorCantidad   = array();
  for ($x = 1; $x <= $cantidadTitulares; $x++) {
    $acumuladorCantidad[$x]   = 0;
  }
  $auxTotal = '';
  //ojo, debo llevar contadores totales y de rubro por cada periodo  SQLSRV_FETCH_ASSOC
  //while (!$RsTemporal->EOF) {
  while( $row = sqlsrv_fetch_array( $RsTemporal, SQLSRV_FETCH_ASSOC)) {  
    if ($rubroAnt != $row['RUBRO']) {
      if ($rubroAnt != -1) {
        $resu .= '      <tr class="subtotales">';
        $resu .= '        <td colspan="3">TOTAL ' . $auxTotal . '</td><td style="display: none"></td><td style="display: none"></td>';
        for ($i = 1; $i <= $cantidadTitulares; $i++) {
          $resu .= '         <td class="numerico">' . number_format($acumuladorCantidad[$i], 2, ',', '.') . '</td>';
        }
        $resu .= '      </tr>';  
      }
      
      $filas = 5 + (($cantidadTitulares-1)*4);
      $resu .= '        <tr class="titulosfilas">';
      $resu .= '          <td style="border: 0;" colspan="3">' . $row['DESC_RUBRO'] . '</td><td style="display: none"></td><td style="display: none"></td>';
      for ($i = 1; $i <= $cantidadTitulares; $i++) {
        $resu .= '         <td style="border: 0;"></td>';
      }
      $resu .= '      </tr>';  
      $rubroAnt = $row['RUBRO'];
      $auxTotal = $row['DESC_RUBRO'];
      for ($z = 1; $z <= $cantidadTitulares; $z++) {
        $acumuladorCantidad[$z]   = 0;
      }
    }
    for ($i = 1; $i <= $cantidadTitulares; $i++) {
      $acumuladorCantidad[$i] = (float)$acumuladorCantidad[$i] + (float)$row['CANTIDAD'.$i];
    }
   
    $auxMostrar = ($muestraCodigo == 1)?'['.$row['BARRA'].']':'['.$row['RUBRO'] . ' - ' . $row['CODIGO'].']';

    $resu .= '      <tr>';
    $resu .= '        <td class="numerales">'.$auxMostrar.'</td><td>' . utf8_encode($row['DESC_INSUMO']) . '</td><td>' . utf8_encode($row['DESC_UNIDAD']) . '</td>';
    for ($i = 1; $i <= $cantidadTitulares; $i++) {
      $resu .= '         <td class="numerico">' . number_format($row['CANTIDAD'.$i], 2, ',', '.') . '</td>';
    }
    $resu .= '      </tr>';  

    //$RsTemporal->MoveNext();
  }
  //pinto el total del último rubro
  $resu .= '      <tr class="subtotales">';
  $resu .= '        <td colspan="3">TOTAL ' . $auxTotal . '</td><td style="display: none"></td><td style="display: none"></td>';
  for ($i = 1; $i <= $cantidadTitulares; $i++) {
    $resu .= '         <td class="numerico">' . number_format($acumuladorCantidad[$i], 2, ',', '.') . '</td>';
  }
  $resu .= '      </tr>
                </tbody>';

  $resu .= '    <!--<tfoot>-->
                  <tr style="background-color: #3e3e3e; color: aliceblue;">
                    <th class="thalign" colspan="3">Total General</th>';

  for ($i = 1; $i <= $cantidadTitulares; $i++) {
    $resu .= '      <th class="thalign">' . number_format($rowTotales['CANTIDAD'.$i], 2, ',', '.') . '</th>';
  }

  $resu .= '      </tr>
                <!--</tfoot>-->
              </div>
            </table>';


  $resu .= '</div>';

  $jsondata = array();
  $jsondata['success'] = true;
  $jsondata['message'] = $resu;
  
  header('Content-type: application/json; charset=utf-8');
  echo json_encode($jsondata);
  die();  
?>